#ifndef _defs_h
#define _defs_h

/*
#ifndef NULL
#define NULL 0
#endif
*/

/*
 * supprimer le commentaire pour utiliser Improv ( + modif dans les nibfiles )
 *	#define USE_IMPROV
 */

/* defintions realisees auparavant dans reseau_de_neurones.h */

#define	EDIT				0
#define	LEARNING			1
#define	INTERRUPTED_LEARN	2
#define	INTERRUPTING_LEARN	3

#define VERSION		7
#define VERSION5	5
#define VERSION6	6
#define VERSION7	7
#define PREFIXE 	"RESEAUX_DE_NEURONES"

/* NBMAXHIDDEN est le nombre max de couche de neurone cachee
 * NBNEURMIN est le nombre minimal de neurone par couche
 */

#define	NBMAXHIDDEN	3
#define	NBNEURMIN	1

#define MAX_NBSTEP	100
#define MIN_NBSTEP	1
#define DEF_NBSTEP	1

#define MAX_NBEPOCH	1000000
#define MIN_NBEPOCH	1
#define DEF_NBEPOCH	1000



/* definitions pour la structure msg_err */

#define	MAX_ERR			(200*MAX_NBSTEP)
#define	MSG_ERR_TYPE	1
#define	MSG_BASE		(sizeof(int)*4)
#define	MSG_MAX			(sizeof(int)*4 + (sizeof(float)*MAX_ERR))


/* definition pour NeuronInspector : */
#define MAXWEIGHT	20.0
#define MINWEIGHT	-20.0



/* definition pour data.c et data.h + ... */

#define MAX_DATA	20000
#define	MAX_INOUT	200
#define MAX_NEURON	200		/* nombre maximum de neurones par couches */

#define BORNE_SIG	4.0
#define BORNE_TANH	2.0

#define	LINEAR1			0
#define	SIGMOIDE		1
#define	LINEAR2			2
#define	TANGENTE_HYPERB	3



/* definitions realisee auparavant dans xdr_routines.h */

#define AXONE_SERVER_PROG     0x30000000	/* numero du programme */
#define AXONE_SERVER_VERS1    1			/* version du programme */

#define AFN_FILS_PROG	0x30000001
#define AFN_FILS_VERS1	1

#define NULL_PROC	0

/* fonctions offertes par le serveur */
#define DEMANDE	1			/* demande un ps pour les calculs */

/* fonctions offertes par les fils du serveur */
#define RECOIT_RESEAU	2	/* recoit le reseau a calculer */
#define RECOIT_DONNEES	3	/* recoit les donnees associee au reseau */
#define CALCUL_EPOQUE	4	/* calcule une epoque */
#define RENVOIE_RESEAU	5	/* renvoie le dernier reseau */
#define LIBERE	6	/* libere le fils utilise pour ce reseau */


/* fonctions offertes par le fils de AFN */
#define RECOIT_ERREUR	1

/* definitions utilises par ImprovIOManager et MesaIOManager */
#define ADD_INPUT		0
#define ADD_OUTPUT		1
#define MODIFY_INPUT	2
#define MODIFY_OUTPUT	3
#define SELECT_MASK		4

typedef struct _arg_epoque
{
	int	nb_epoques ;
	int	attente ;

	int	best ;	/* un flag qui indique si on conserve le meilleur reseau */
	int	shake ;	/* un flag qui indique si on effectue un shake */
	float	range1 ;	/* interval initial */
	float	range2 ;	/* interval final */
	int	nbshake ;	/* nombre de shake pour passer de range1 a range2 */
	int	step ;	/* nombre depoques entre deux shake */
	int	first_epoque ;	/*indice de la premiere epoque */
	int	bestPeriod ;	/*period du keep Best */
}	arg_epoque;

#endif